# remirepo/Fedora spec file for php-zendframework-zend-authentication
#
# Copyright (c) 2015-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    ebc9464c11a5203e5256439f1079a7d6efe89eec
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-authentication
%global php_home     %{_datadir}/php
%global library      Authentication
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.6.0
Release:        4%{?dist}
Summary:        Zend Framework %{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-ctype
BuildRequires:  php-date
BuildRequires:  php-hash
BuildRequires:  php-pcre
BuildRequires:  php-spl
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.1
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.2",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-crypt": "^2.6 || ^3.2.1",
#        "zendframework/zend-db": "^2.8.2",
#        "zendframework/zend-http": "^2.7",
#        "zendframework/zend-ldap": "^2.8",
#        "zendframework/zend-session": "^2.8",
#        "zendframework/zend-uri": "^2.5.2",
#        "zendframework/zend-validator": "^2.10.1"
BuildRequires:  php-autoloader(%{gh_owner}/zend-db)             >= 2.8.2
BuildRequires:  php-autoloader(%{gh_owner}/zend-crypt)          >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-http)           >= 2.7
BuildRequires:  php-autoloader(%{gh_owner}/zend-ldap)           >= 2.8
BuildRequires:  php-autoloader(%{gh_owner}/zend-session)        >= 2.8
BuildRequires:  php-autoloader(%{gh_owner}/zend-uri)            >= 2.5.2
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)      >= 2.10.1
%global phpunit %{_bindir}/phpunit7
BuildRequires:  %{phpunit}
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-stdlib": "^2.7.7 || ^3.1"
Requires:       php(language) >= 5.6
%if ! %{bootstrap}
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.1
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         <  4
# From composer, "suggest": {
#        "zendframework/zend-db": "Zend\\Db component",
#        "zendframework/zend-crypt": "Zend\\Crypt component",
#        "zendframework/zend-http": "Zend\\Http component",
#        "zendframework/zend-ldap": "Zend\\Ldap component",
#        "zendframework/zend-session": "Zend\\Session component",
#        "zendframework/zend-uri": "Zend\\Uri component",
#        "zendframework/zend-validator": "Zend\\Validator component"
Suggests:       php-autoloader(%{gh_owner}/zend-db)
Suggests:       php-autoloader(%{gh_owner}/zend-crypt)
Suggests:       php-autoloader(%{gh_owner}/zend-http)
Suggests:       php-autoloader(%{gh_owner}/zend-ldap)
Suggests:       php-autoloader(%{gh_owner}/zend-session)
Suggests:       php-autoloader(%{gh_owner}/zend-uri)
Suggests:       php-autoloader(%{gh_owner}/zend-validator)
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.5.2
Requires:       php-ctype
Requires:       php-date
Requires:       php-hash
Requires:       php-pcre
Requires:       php-spl

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
The Zend\Authentication component provides an API for authentication and
includes concrete authentication adapters for common use case scenarios.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Generate autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Stdlib/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/Db/autoload.php',
    '%{php_home}/Zend/Crypt/autoload.php',
    '%{php_home}/Zend/Http/autoload.php',
    '%{php_home}/Zend/Ldap/autoload.php',
    '%{php_home}/Zend/Session/autoload.php',
    '%{php_home}/Zend/Uri/autoload.php',
    '%{php_home}/Zend/Validator/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php70 %{_bindir}/phpunit6" php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Mon Apr 16 2018 Remi Collet <remi@remirepo.net> - 2.6.0-2
- update to 2.6.0
- raise dependency on PHP 5.6
- raise dependency on zend-stdlib 3.1
- use phpunit7

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.3-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Dec 11 2017 Remi Collet <remi@remirepo.net> - 2.5.3-4
- switch from zend-loader to fedora/autoloader

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Sun Feb 28 2016 Remi Collet <remi@fedoraproject.org> - 2.5.3-1
- update to 2.5.3
- raise dependency on zend-stdlib ~2.7

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- initial package